// ShiftFox.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

// Global Variables:
HINSTANCE hInst;		// current instance
HANDLE hndlMyMutex;		//"Already opened" mutex handle

// Forward declarations of functions included in this code module:
void                RegHotKey(HWND hWnd);
void                UnregHotKey(HWND hWnd);
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	
	//Make sure we're alone here...
	hndlMyMutex=CreateMutex(NULL,FALSE,"ShiftFoxActive");
	if (GetLastError()==ERROR_ALREADY_EXISTS) return FALSE;

	//Register the class
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}


void RegHotKey(HWND hWnd) 
{
	ATOM aHotKey=GlobalAddAtom("ShiftFoxHotKey");
	BOOL bret = RegisterHotKey(hWnd,aHotKey,MOD_CONTROL|MOD_SHIFT,VK_SHIFT);
	//NO ERROR HANDLING intentionally!
}

void UnregHotKey(HWND hWnd) 
{
	ATOM aHotKey=GlobalFindAtom("ShiftFoxHotKey");
	UnregisterHotKey(hWnd,aHotKey);
	//NO ERROR HANDLING intentionally!
	GlobalDeleteAtom(aHotKey);
}


//
//  FUNCTION: MyRegisterClass()  (From auto-generated code)
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SHIFTFOX);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName   = NULL;
	wcex.lpszClassName	= "SHIFTFOX";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)  (From auto-generated code)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow("SHIFTFOX", "ShiftFox listener", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   ShowWindow(hWnd, SW_HIDE);
   UpdateWindow(hWnd);

   //Make sure the window is hidden!
   ShowWindow(hWnd, SW_HIDE);
   UpdateWindow(hWnd);


   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	//No visible window, so no WM_PAINT needed, put it back in if you really want to.
/*	PAINTSTRUCT ps;
	HDC hdc;*/
	
	HWND FhWnd;

	switch (message) 
	{
/*		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			RECT rt;
			GetClientRect(hWnd, &rt);
			// TODO: Add any drawing code here...
			break;*/
		case WM_CREATE:
				SetTimer(hWnd,1,250,NULL);
				break;
		case WM_TIMER:
			//*** If Foreground Window is of class "MozillaUIWindowClass" or "MozillaWindowClass" - 
			//*** Register the hotkey. Otherwise - Unreg it.
			int ret;
			char ClsName[50];
			FhWnd=GetForegroundWindow();
			ret=GetClassName(FhWnd,ClsName,50);
			
			if ((ret>0) && ((strcmp(ClsName,"MozillaUIWindowClass")==0) || (strcmp(ClsName,"MozillaWindowClass")==0))) 
				RegHotKey(hWnd);
			else 
				UnregHotKey(hWnd);

			break;
		case WM_HOTKEY:
			//*** Aim: Send Ctrl-Shift-X

			//Unmap the delicate bastard (To avoid an infinite loop)
			UnregHotKey(hWnd);
			// Simulate a key press
			keybd_event(VK_CONTROL,0,KEYEVENTF_EXTENDEDKEY | 0, 0 );
			keybd_event(VK_SHIFT,0,KEYEVENTF_EXTENDEDKEY | 0, 0 );
			keybd_event('X',0,0, 0 ); //VK_X equals X's char code
			// Simulate a key release
			keybd_event('X',0,KEYEVENTF_KEYUP,0);
			keybd_event(VK_SHIFT,0,KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP,0);
			keybd_event(VK_CONTROL,0,KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP,0);
			
			//Remap it!
			RegHotKey(hWnd);

			break;
		case WM_DESTROY:
			CloseHandle(hndlMyMutex);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


